// convf.c
//
// YV12 -> YUY2 ϊ֐iJ[AbvTvj
//
// func(unsigned char *dst, unsigned char *src, unsigned char *temp, 
//      long width_in, long width_out, long height)
//   unsigned char *dst  : Rs[ւ̃|C^
//   unsigned char *src  : Rs[
//   unsigned char *temp : e|̈iTCY width_in * height * 2j
//   long width_in       : ͉摜̕iXgCh܂ށj
//   long width_out      : o͉摜̕iXgCh܂ށj
//   long height         : 摜̍
//
// ۂ̉摜͓̈̕nȂ̂ŁAwidth_in  width_out ̏ق̕Rs[
//
// YUY2:
//   Y0 U0 Y1 V0
// YV12:(s:stride)
//   YYss
//   YYss
//   Vs
//   Us
//
// V,U͎ۂ̒l128́B܂YUVׂ unsigned char ƈ
//
#include "convf.h"

#ifdef __cplusplus
extern "C"
{
#endif

static void yv12_2_yuy2(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void yv12_2_yuy2_2(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void yv12_2_yuy2_4(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void yv12_2_yuy2_6(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void yv12_2_yuy2_2y(unsigned char *, unsigned char *, unsigned char *, long, long, long);

static void iyv12_2_yuy2(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_2(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_2x(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_4(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_4x(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_6(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_6x(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_2y(unsigned char *, unsigned char *, unsigned char *, long, long, long);
static void iyv12_2_yuy2_2xy(unsigned char *, unsigned char *, unsigned char *, long, long, long);

#ifdef __cplusplus
} 
#endif


// ϊ֐e[u ֐̐"FUNC_N"ł̓~Xh~̂߂炩ߐݒ肵Ă
void (*func_tbl[FUNC_N])(unsigned char *, unsigned char *, unsigned char *, long, long, long) = {
	yv12_2_yuy2,
	yv12_2_yuy2_2,
	yv12_2_yuy2_4,
	yv12_2_yuy2_6,
	yv12_2_yuy2_2y,
	iyv12_2_yuy2,
	iyv12_2_yuy2_2,
	iyv12_2_yuy2_2x,
	iyv12_2_yuy2_4,
	iyv12_2_yuy2_4x, 
	iyv12_2_yuy2_6,
	iyv12_2_yuy2_6x,
	iyv12_2_yuy2_2y,
	iyv12_2_yuy2_2xy
};


/*
 *   p[eBeB[֐
 */
static void transpose(unsigned char *, unsigned char *, long, long, long);

/*
 * vO YV12 -> YUY2
 * nearest neighbor
 *
 */
static void yv12_2_yuy2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int h_width = width_in >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp, *src_vtmp;
	unsigned char *src_v = src + offsY;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp = src_v + (i>>1) * h_width;
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			*(dst_tmp + 1) = *(src_vtmp + offsV);
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			*(dst_tmp + 3) = *src_vtmp;

			src += 2;
			src_vtmp++;
			dst_tmp += 4;
		}
	}
}


/*
 * vO YV12 -> YUY2
 * 2Tv
 * W 0.75, 0.25
 * 
 */
static void yv12_2_yuy2_2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int uv_tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0 = src_v;
	unsigned char *src_vtmp1;

	// ŏ1line
	for(j=0; j<h_width; ++j) {
		//Y0
		*dst_tmp       = *src;
		//U0
		*(dst_tmp + 1) = *(src_vtmp0 + offsV);
		//Y1
		*(dst_tmp + 2) = *(src + 1);
		//V0
		*(dst_tmp + 3) = *src_vtmp0;

		src += 2;
		src_vtmp0++;
		dst_tmp += 4;
	}

	--height;
	for(i=1; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp0 = src_v + (i>>1) * h_width;
		src_vtmp1 = src_vtmp0 + ((1&i)*2 - 1) * h_width;
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			uv_tmp = *(src_vtmp0 + offsV) * 3 + *(src_vtmp1 + offsV);
			uv_tmp >>= 2;
			*(dst_tmp + 1) = uv_tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			uv_tmp = *src_vtmp0 * 3 + *src_vtmp1;
			uv_tmp >>= 2;
			*(dst_tmp + 3) = uv_tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			dst_tmp += 4;
		}
	}

	//Ō1C
	dst_tmp = dst + (i+i) * width_out;
	src_vtmp0 = src_v + (h_height-1) * h_width;
	for(j=0; j<h_width; ++j) {
		//Y0
		*dst_tmp       = *src;
		//U0
		*(dst_tmp + 1) = *(src_vtmp0 + offsV);
		//Y1
		*(dst_tmp + 2) = *(src + 1);
		//V0
		*(dst_tmp + 3) = *src_vtmp0;

		src += 2;
		src_vtmp0++;
		dst_tmp += 4;
	}

}

/*
 * vO YV12 -> YUY2
 * 4Tv
 * W -0.083, 0.87, 0.23, -0.017
 *
 * uv_tmp = *(src_vtmp0 + offsV) * 0.8686  + *(src_vtmp1 + offsV) * 0.2330
 *			- *(src_vtmp2 + offsV) * 0.08388 - *(src_vtmp3 + offsV) * 0.01772;
 * 
 */
static void yv12_2_yuy2_4(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int tmp;
	int l1, l2, l3;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1, *src_vtmp2, *src_vtmp3;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		tmp = (i>>1);
		src_vtmp0 = src_v + tmp * h_width;
		l1 = (1&i)*2 - 1;
		l2 = tmp - l1;
		l3 = tmp + l1 + l1;
		l1 += tmp;

		if(l3>0 && l3<h_height){
			src_vtmp3 = src_v + l3 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
		}else if(l1>0 && l1<h_height){
			src_vtmp3 = src_vtmp1 = src_v + l1 * h_width;
		}else{
			src_vtmp3 = src_vtmp1 = src_v;
		}

		if(l2>0 && l2<h_height){
			src_vtmp2 = src_v + l2 * h_width;
		}else{
			src_vtmp2 = src_v;
		}

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp =   *(src_vtmp0 + offsV) * 28462 + *(src_vtmp1 + offsV) * 7635
				  - *(src_vtmp2 + offsV) * 2748  - *(src_vtmp3 + offsV) * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp =   *src_vtmp0 * 28462 + *src_vtmp1 * 7635
				  - *src_vtmp2 * 2748  - *src_vtmp3 * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			src_vtmp2++;
			src_vtmp3++;
			dst_tmp += 4;
		}
	}
}

/*
 * vO YV12 -> YUY2
 * 6Tv
 * W 0.0300, -0.133, 0.890, 0.270, -0.0678, 0.00735
 * 
 * uv_tmp = *(src_vtmp0 + offsV) * 0.89277  + *(src_vtmp1 + offsV) * 0.27101
 *          - *(src_vtmp2 + offsV) * 0.133274 - *(src_vtmp3 + offsV) * 0.067996
 *          + *(src_vtmp4 + offsV) * 0.030112 + *(src_vtmp5 + offsV) * 0.007378;
 */
static void yv12_2_yuy2_6(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int tmp;
	int l1,l2,l3,l4,l5;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1, *src_vtmp2;
	unsigned char *src_vtmp3, *src_vtmp4, *src_vtmp5;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		tmp = i>>1;
		src_vtmp0 = src_v + tmp * h_width;
		l1 = (1&i)*2 - 1;
		l2 = tmp - l1;
		l3 = tmp + l1 + l1;
		l4 = l2 - l1;
		l5 = l3 + l1;
		l1 += tmp;

		if(l5>0 && l5<h_height){
			src_vtmp5 = src_v + l5 * h_width;
			src_vtmp3 = src_v + l3 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
		}else if(l3>0 && l3<h_height){
			src_vtmp5 = src_vtmp3 = src_v + l3 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
		}else if(l1>0 && l1<h_height){
			src_vtmp5 = src_vtmp3 = src_vtmp1 = src_v + l1 * h_width;
		}else{
			src_vtmp5 = src_vtmp3 = src_vtmp1 = src_v;
		}

		if(l4>0 && l4<h_height){
			src_vtmp4 = src_v + l4 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
		}else if(l2>0 && l2<h_height){
			src_vtmp4 = src_vtmp2 = src_v + l2 * h_width;
		}else{
			src_vtmp4 = src_vtmp2 = src_v;
		}

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp =   *(src_vtmp0 + offsV) * 29254 + *(src_vtmp1 + offsV) * 8880
                  - *(src_vtmp2 + offsV) * 4367  - *(src_vtmp3 + offsV) * 2228
			      + *(src_vtmp4 + offsV) * 987   + *(src_vtmp5 + offsV) * 242;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp =   *src_vtmp0 * 29254 + *src_vtmp1 * 8880
				  - *src_vtmp2 * 4367  - *src_vtmp3 * 2228
				  + *src_vtmp4 * 987   + *src_vtmp5 * 242;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			src_vtmp2++;
			src_vtmp3++;
			src_vtmp4++;
			src_vtmp5++;
			dst_tmp += 4;
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * nearest neighbor
 *
 */
static void iyv12_2_yuy2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int h_width = width_in >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp, *src_vtmp;
	unsigned char *src_v = src + offsY;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp = src_v + (2*(i>>2) + (i&1)) * h_width;
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			*(dst_tmp + 1) = *(src_vtmp + offsV);
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			*(dst_tmp + 3) = *src_vtmp;

			src += 2;
			src_vtmp++;
			dst_tmp += 4;
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 2Tv(Tv_YĂ^Cv:MPEG2)
 * W {0.875, 0.125} or {0.625, 0.375}
 * 
 */
static void iyv12_2_yuy2_2(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0,l1;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;

		if(((i+1)>>1)&1) { // i=1,2,5,6,9,10,13,14...
			l0 = (i>>1) + ((1&i)*2 - 1);
			l1 = (i>>1) - ((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}else if(l0>=h_height){
				l0 = l1;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp = *(src_vtmp0 + offsV) * 5 + *(src_vtmp1 + offsV) * 3;
				tmp >>= 3;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp = *src_vtmp0 * 5 + *src_vtmp1 * 3;
				tmp >>= 3;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				dst_tmp += 4;
			}
		}else{ // i=0,3,4,7,8,11,12,15,16,...
			l0 = i>>1;
			l1 = l0 + 2*((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp = *(src_vtmp0 + offsV) * 7 + *(src_vtmp1 + offsV);
				tmp >>= 3;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp = *src_vtmp0 * 7 + *src_vtmp1;
				tmp >>= 3;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				dst_tmp += 4;
			}
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 2Tv(Tv_^񒆂ɂꍇ)
 * W 0.75, 0.25
 * 
 */
static void iyv12_2_yuy2_2x(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0, l1;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		l0 = 2*(i>>2) + (i&1);
		l1 = l0 + ((i>>1)&1) * 4 - 2;
		if(l1<0 || l1>=h_height) {
			l1 = l0;
		}
		src_vtmp0 = src_v + l0 * h_width;
		src_vtmp1 = src_v + l1 * h_width;

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp = *(src_vtmp0 + offsV) * 3 + *(src_vtmp1 + offsV);
			tmp >>= 2;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp = *src_vtmp0 * 3 + *src_vtmp1;
			tmp >>= 2;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			dst_tmp += 4;
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 4Tv(Tv_YĂ^Cv)
 * W   {-0.059904, 0.965168, 0.0990252, -0.0042892} 
 *      or{-0.0810047, 0.7276928, 0.3920645, -0.0387526}
 * 
 */
static void iyv12_2_yuy2_4(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0,l1,l2,l3;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1,*src_vtmp2, *src_vtmp3;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;

		if(((i+1)>>1)&1) { // i=1,2,5,6,9,10,13,14...
			l0 = (i>>1) + ((1&i)*2 - 1);
			l1 = (i>>1) - ((1&i)*2 - 1);
			l2 = l0 + (1&i)*4 - 2;
			l3 = l1 - (1&i)*4 + 2;
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}else if(l0>=h_height){
				l0 = l1;
			}
			if(l2<0 || l2>=h_height) {
				l2 = l0;
			}
			if(l3<0 || l3>=h_height) {
				l3 = l1;
			}

			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
			src_vtmp3 = src_v + l3 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp =   *(src_vtmp0 + offsV) * 23845 + *(src_vtmp1 + offsV) * 12847
					  - *(src_vtmp2 + offsV) * 2654  - *(src_vtmp3 + offsV) * 1270;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp =   *src_vtmp0 * 23845 + *src_vtmp1 * 12847
					  - *src_vtmp2 * 2654  - *src_vtmp3 * 1270;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				src_vtmp2++;
				src_vtmp3++;
				dst_tmp += 4;
			}
		}else{ // i=0,3,4,7,8,11,12,15,16,...
			l0 = i>>1;
			l1 = l0 + 2*((1&i)*2 - 1);
			l2 = l0 - 2*((1&i)*2 - 1);
			l3 = l1 + 2*((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}
			if(l2<0 || l2>=h_height) {
				l2 = l0;
			}
			if(l3<0 || l3>=h_height) {
				l3 = l1;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
			src_vtmp3 = src_v + l3 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp =   *(src_vtmp0 + offsV) * 31626 + *(src_vtmp1 + offsV) * 3245
					  - *(src_vtmp2 + offsV) * 1963  - *(src_vtmp3 + offsV) * 140;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp =   *src_vtmp0 * 31626 + *src_vtmp1 * 3245
					  - *src_vtmp2 * 1963  - *src_vtmp3 * 140;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				src_vtmp2++;
				src_vtmp3++;
				dst_tmp += 4;
			}
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 4Tv(Tv_^񒆂ɂꍇ)
 * W -0.08388, 0.8686, 0.2330, -0.01772
 * 
 */
static void iyv12_2_yuy2_4x(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0, l1, l2, l3;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1, *src_vtmp2, *src_vtmp3;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		l0 = 2*(i>>2) + (i&1);
		l1 = l0 + ((i>>1)&1) * 4 - 2;
		l2 = l0 - ((i>>1)&1) * 4 + 2;
		l3 = l1 + ((i>>1)&1) * 4 - 2;
		if(l1<0 || l1>=h_height) {
			l1 = l0;
		}
		if(l2<0 || l2>=h_height) {
			l2 = l0;
		}
		if(l3<0 || l3>=h_height) {
			l3 = l1;
		}

		src_vtmp0 = src_v + l0 * h_width;
		src_vtmp1 = src_v + l1 * h_width;
		src_vtmp2 = src_v + l2 * h_width;
		src_vtmp3 = src_v + l3 * h_width;

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp =   *(src_vtmp0 + offsV) * 28462 + *(src_vtmp1 + offsV) * 7635
				  - *(src_vtmp2 + offsV) * 2748  - *(src_vtmp3 + offsV) * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp =   *src_vtmp0 * 28462 + *src_vtmp1 * 7635
				  - *src_vtmp2 * 2748  - *src_vtmp3 * 581;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			src_vtmp2++;
			src_vtmp3++;
			dst_tmp += 4;
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 6Tv(Tv_YĂ^Cv)
 * W   {0.0204565, -0.084993, 0.972645, 0.12065, -0.030597, 0.00183876} 
 *      or{0.0304584, -0.1479961, 0.768006, 0.4398197, -0.10596, 0.015637}
 * 
 */
static void iyv12_2_yuy2_6(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0,l1,l2,l3,l4,l5;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1, *src_vtmp2;
	unsigned char *src_vtmp3, *src_vtmp4, *src_vtmp5;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;

		if(((i+1)>>1)&1) { // i=1,2,5,6,9,10,13,14...
			l0 = (i>>1) + ((1&i)*2 - 1);
			l1 = (i>>1) - ((1&i)*2 - 1);
			l2 = l0 + l0 - l1;
			l3 = l1 + l1 - l0;
			l4 = l2 + l0 - l1;
			l5 = l3 + l1 - l0;;
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}else if(l0>=h_height){
				l0 = l1;
			}
			if(l2<0 || l2>=h_height) {
				l2 = l0;
			}
			if(l3<0 || l3>=h_height) {
				l3 = l1;
			}
			if(l4<0 || l4>=h_height) {
				l4 = l2;
			}
			if(l5<0 || l5>=h_height) {
				l5 = l3;
			}

			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
			src_vtmp3 = src_v + l3 * h_width;
			src_vtmp4 = src_v + l4 * h_width;
			src_vtmp5 = src_v + l5 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp =   *(src_vtmp0 + offsV) * 25166 + *(src_vtmp1 + offsV) * 14412
					  - *(src_vtmp2 + offsV) * 4850  - *(src_vtmp3 + offsV) * 3472
					  + *(src_vtmp4 + offsV) * 998   + *(src_vtmp5 + offsV) * 514;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp =   *src_vtmp0 * 25166 + *src_vtmp1 * 14412
					  - *src_vtmp2 * 4850  - *src_vtmp3 * 3472
					  + *src_vtmp4 * 998   + *src_vtmp5 * 514;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				src_vtmp2++;
				src_vtmp3++;
				src_vtmp4++;
				src_vtmp5++;
				dst_tmp += 4;
			}
		}else{ // i=0,3,4,7,8,11,12,15,16,...
			l0 = i>>1;
			tmp = 2*((1&i)*2 - 1);
			l1 = l0 + tmp;
			l2 = l0 - tmp;
			l3 = l1 + tmp;
			l4 = l2 - tmp;
			l5 = l3 + tmp;
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}
			if(l2<0 || l2>=h_height) {
				l2 = l0;
			}
			if(l3<0 || l3>=h_height) {
				l3 = l1;
			}
			if(l4<0 || l4>=h_height) {
				l4 = l2;
			}
			if(l5<0 || l5>=h_height) {
				l5 = l3;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;
			src_vtmp2 = src_v + l2 * h_width;
			src_vtmp3 = src_v + l3 * h_width;
			src_vtmp4 = src_v + l4 * h_width;
			src_vtmp5 = src_v + l5 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//U0
				tmp =   *(src_vtmp0 + offsV) * 31872 + *(src_vtmp1 + offsV) * 3954
					  - *(src_vtmp2 + offsV) * 2785  - *(src_vtmp3 + offsV) * 1003
					  + *(src_vtmp4 + offsV) * 670   + *(src_vtmp5 + offsV) * 60;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp =   *src_vtmp0 * 31872 + *src_vtmp1 * 3954
					  - *src_vtmp2 * 2785  - *src_vtmp3 * 1003
					  + *src_vtmp4 * 670   + *src_vtmp5 * 60;
				tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
				tmp = (tmp > 255) ? 255 : tmp;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				src_vtmp2++;
				src_vtmp3++;
				src_vtmp4++;
				src_vtmp5++;
				dst_tmp += 4;
			}
		}
	}
}

/*
 * interlaced YV12 -> YUY2
 * 6Tv(Tv_^񒆂ɂꍇ)
 * W 0.0300, -0.133, 0.890, 0.270, -0.0678, 0.00735
 * 
 */
static void iyv12_2_yuy2_6x(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j;
	int l0, l1, l2, l3, l4, l5;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1,*src_vtmp2;
	unsigned char *src_vtmp3, *src_vtmp4,*src_vtmp5;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		l0 = 2*(i>>2) + (i&1);
		tmp = ((i>>1)&1) * 4 - 2;
		l1 = l0 + tmp;
		l2 = l0 - tmp;
		l3 = l1 + tmp;
		l4 = l2 - tmp;
		l5 = l3 + tmp;
		if(l1<0 || l1>=h_height) {
			l1 = l0;
		}
		if(l2<0 || l2>=h_height) {
			l2 = l0;
		}
		if(l3<0 || l3>=h_height) {
			l3 = l1;
		}
		if(l4<0 || l4>=h_height) {
			l4 = l2;
		}
		if(l5<0 || l5>=h_height) {
			l5 = l3;
		}

		src_vtmp0 = src_v + l0 * h_width;
		src_vtmp1 = src_v + l1 * h_width;
		src_vtmp2 = src_v + l2 * h_width;
		src_vtmp3 = src_v + l3 * h_width;
		src_vtmp4 = src_v + l4 * h_width;
		src_vtmp5 = src_v + l5 * h_width;

		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//U0
			tmp =   *(src_vtmp0 + offsV) * 29254 + *(src_vtmp1 + offsV) * 8880
                  - *(src_vtmp2 + offsV) * 4367  - *(src_vtmp3 + offsV) * 2228
			      + *(src_vtmp4 + offsV) * 987   + *(src_vtmp5 + offsV) * 242;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp =   *src_vtmp0 * 29254 + *src_vtmp1 * 8880
				  - *src_vtmp2 * 4367  - *src_vtmp3 * 2228
				  + *src_vtmp4 * 987   + *src_vtmp5 * 242;
			tmp = (tmp > 0) ?  (tmp + 16383) >> 15 : 0;
			tmp = (tmp > 255) ? 255 : tmp;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			src_vtmp2++;
			src_vtmp3++;
			src_vtmp4++;
			src_vtmp5++;
			dst_tmp += 4;
		}
	}
}

/*
 * YV12 -> YUY2 2Tv Px񗘗p ̌W
 */
static int coeff[] = {
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32622, 32477, 32333, 32192, 32051, 31913,
	31775, 31640, 31505, 31372, 31240, 31109, 30980, 30852,
	30725, 30598, 30473, 30349, 30226, 30104, 29983, 29862,
	29743, 29624, 29506, 29389, 29272, 29157, 29041, 28927,
	28813, 28700, 28587, 28475, 28364, 28253, 28143, 28033,
	27923, 27814, 27706, 27598, 27490, 27382, 27275, 27169,
	27063, 26957, 26851, 26746, 26640, 26536, 26431, 26327,
	26223, 26119, 26015, 25911, 25808, 25705, 25602, 25499,
	25396, 25293, 25190, 25088, 24985, 24883, 24780, 24678,
	24576, 24473, 24371, 24268, 24166, 24063, 23961, 23858,
	23755, 23652, 23549, 23446, 23343, 23240, 23136, 23032,
	22928, 22824, 22720, 22615, 22511, 22405, 22300, 22194,
	22088, 21982, 21876, 21769, 21661, 21553, 21445, 21337,
	21228, 21118, 21008, 20898, 20787, 20676, 20564, 20451,
	20338, 20224, 20110, 19994, 19879, 19762, 19645, 19527,
	19408, 19289, 19168, 19047, 18925, 18802, 18678, 18553,
	18426, 18299, 18171, 18042, 17911, 17779, 17646, 17511,
	17376, 17238, 17100, 16959, 16818, 16674, 16529, 16383,
	16234, 16083, 15930, 15776, 15619, 15459, 15298, 15133,
	14967, 14797, 14625, 14450, 14272, 14090, 13905, 13717,
	13525, 13328, 13128, 12923, 12714, 12499, 12280, 12055,
	11824, 11587, 11343, 11091, 10833, 10566, 10290, 10004,
	9708, 9401, 9082, 8749, 8402, 8038, 7656, 7254,
	6829, 6379, 5900, 5387, 4835, 4238, 3587, 2870,
	2072, 1170, 134, 0, 0, 0, 0, 0 };

static int coeff_i2[] = {
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32557, 32342, 32133, 31928, 31728,
	31531, 31339, 31151, 30966, 30784, 30606, 30431, 30259,
	30089, 29923, 29758, 29597, 29437, 29280, 29126, 28973,
	28822, 28673, 28526, 28381, 28237, 28096, 27955, 27817,
	27679, 27544, 27409, 27276, 27144, 27013, 26884, 26756,
	26629, 26502, 26377, 26253, 26130, 26008, 25887, 25766,
	25647, 25528, 25410, 25293, 25176, 25061, 24945, 24831,
	24717, 24604, 24491, 24379, 24268, 24157, 24047, 23937,
	23827, 23718, 23610, 23502, 23394, 23286, 23179, 23073,
	22967, 22861, 22755, 22650, 22544, 22440, 22335, 22231,
	22127, 22023, 21919, 21815, 21712, 21609, 21506, 21403,
	21300, 21197, 21094, 20992, 20889, 20787, 20684, 20582,
	20480, 20377, 20275, 20172, 20070, 19967, 19865, 19762,
	19659, 19556, 19453, 19350, 19247, 19144, 19040, 18936,
	18832, 18728, 18624, 18519, 18415, 18309, 18204, 18098,
	17992, 17886, 17780, 17673, 17565, 17457, 17349, 17241,
	17132, 17022, 16912, 16802, 16691, 16580, 16468, 16356,
	16243, 16129, 16015, 15899, 15784, 15667, 15550, 15432,
	15313, 15194, 15073, 14952, 14830, 14707, 14583, 14458,
	14331, 14204, 14076, 13947, 13816, 13684, 13551, 13416,
	13281, 13143, 13005, 12864, 12723, 12579, 12434, 12287,
	12138, 11987, 11834, 11680, 11523, 11363, 11202, 11037,
	10871, 10701, 10529, 10354, 10176, 9994, 9809, 9621,
	9429, 9232, 9032, 8827, 8618, 8403, 8184, 7959,
	7728, 7491, 7247, 6995, 6737, 6470, 6194, 5908,
	5612, 5305, 4986, 4653, 4306, 3942, 3560, 3158,
	2733, 2283, 1804, 1291, 739, 142, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0 };

static int coeff_i1[] = {
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32768, 32768, 32768, 32768, 32768, 32768,
	32768, 32768, 32683, 32571, 32460, 32349, 32239, 32129,
	32019, 31910, 31802, 31694, 31586, 31478, 31371, 31265,
	31159, 31053, 30947, 30842, 30736, 30632, 30527, 30423,
	30319, 30215, 30111, 30007, 29904, 29801, 29698, 29595,
	29492, 29389, 29286, 29184, 29081, 28979, 28876, 28774,
	28672, 28569, 28467, 28364, 28262, 28159, 28057, 27954,
	27851, 27748, 27645, 27542, 27439, 27336, 27232, 27128,
	27024, 26920, 26816, 26711, 26607, 26501, 26396, 26290,
	26184, 26078, 25972, 25865, 25757, 25649, 25541, 25433,
	25324, 25214, 25104, 24994, 24883, 24772, 24660, 24547,
	24434, 24320, 24206, 24090, 23975, 23858, 23741, 23623,
	23504, 23385, 23264, 23143, 23021, 22898, 22774, 22649,
	22522, 22395, 22267, 22138, 22007, 21875, 21742, 21607,
	21472, 21334, 21196, 21055, 20914, 20770, 20625, 20478,
	20329, 20178, 20025, 19871, 19714, 19554, 19393, 19228,
	19062, 18892, 18720, 18545, 18367, 18185, 18000, 17812,
	17620, 17423, 17223, 17018, 16809, 16594, 16376, 16151,
	15920, 15683, 15439, 15187, 14929, 14662, 14386, 14100,
	13804, 13497, 13178, 12845, 12498, 12134, 11752, 11350,
	10925, 10475, 9996, 9483, 8931, 8334, 7683, 6966,
	6168, 5266, 4230, 3009, 1520, 0, 0, 0 };

/*
 * vO YV12 -> YUY2
 * 2Tv Pxp
 *  
 */
static void yv12_2_yuy2_2y(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j,k;
	int a,b,c,d;
	int uv_tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0 = src_v;
	unsigned char *src_vtmp1;

	// ŏ1line
	for(j=0; j<h_width; ++j) {
		//Y0
		*dst_tmp       = *src;
		//U0
		*(dst_tmp + 1) = *(src_vtmp0 + offsV);
		//Y1
		*(dst_tmp + 2) = *(src + 1);
		//V0
		*(dst_tmp + 3) = *src_vtmp0;

		src += 2;
		src_vtmp0++;
		dst_tmp += 4;
	}

	--height;
	for(i=1; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		src_vtmp0 = src_v + (i>>1) * h_width;
		src_vtmp1 = src_vtmp0 + ((1&i)*2 - 1) * h_width;
		d = (1&i)*2 - 1; //C1A-1
		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//Px̌Xŏd݂ύX
			a = *(src - d*width_in);
			b = *(src + d*width_in);
			c = *src;
			k = a>b ? (a-c)+(127-((a-b)>>1)) : (c-a)+(127-((b-a)>>1));
			k = k<0 ? 0 : k;
			k = k>255 ? 255 : k;
			//U0
			uv_tmp = *(src_vtmp0 + offsV) * coeff[k] + *(src_vtmp1 + offsV) * ((1<<15) - coeff[k]);
			uv_tmp = (uv_tmp + 16383) >> 15;
			*(dst_tmp + 1) = uv_tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			uv_tmp = *src_vtmp0 * coeff[k] + *src_vtmp1 * ((1<<15) - coeff[k]) + 16383;
			uv_tmp >>= 15;
			*(dst_tmp + 3) = uv_tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			dst_tmp += 4;
		}
	}

	//Ō1C
	dst_tmp = dst + (i+i) * width_out;
	src_vtmp0 = src_v + (h_height-1) * h_width;
	for(j=0; j<h_width; ++j) {
		//Y0
		*dst_tmp       = *src;
		//U0
		*(dst_tmp + 1) = *(src_vtmp0 + offsV);
		//Y1
		*(dst_tmp + 2) = *(src + 1);
		//V0
		*(dst_tmp + 3) = *src_vtmp0;

		src += 2;
		src_vtmp0++;
		dst_tmp += 4;
	}

}

/*
 * Pxp interlaced YV12 -> YUY2
 * 2Tv(Tv_YĂ^Cv:MPEG2)
 * 
 */
static void iyv12_2_yuy2_2y(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j,k;
	int a,b,c,d;
	int l0,l1;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		d = 2*((i&2) - 1);
		if(i<2|| i>=height-2) {
			d = 0;
		}

		if(((i+1)>>1)&1) { // i=1,2,5,6,9,10,13,14...
			l0 = (i>>1) + ((1&i)*2 - 1);
			l1 = (i>>1) - ((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}else if(l0>=h_height){
				l0 = l1;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//Px̌Xŏd݂ύX
				a = *(src - d*width_in);
				b = *(src + d*width_in);
				c = *src;
				k = a>b ? (a-c)+(127-((a-b)>>1)) : (c-a)+(127-((b-a)>>1));
				k = k<0 ? 0 : k;
				k = k>255 ? 255 : k;
				//U0
				tmp = *(src_vtmp0 + offsV) * coeff_i1[k] + *(src_vtmp1 + offsV) * ((1<<15) - coeff_i1[k]);
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp = *src_vtmp0 * coeff_i1[k] + *src_vtmp1 * ((1<<15) - coeff_i1[k]);
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				dst_tmp += 4;
			}
		}else{ // i=0,3,4,7,8,11,12,15,16,...
			l0 = i>>1;
			l1 = l0 + 2*((1&i)*2 - 1);
			if(l1<0 || l1>=h_height) {
				l1 = l0;
			}
			src_vtmp0 = src_v + l0 * h_width;
			src_vtmp1 = src_v + l1 * h_width;

			for(j=0; j<h_width; ++j) {
				//Y0
				*dst_tmp       = *src;
				//Px̌Xŏd݂ύX
				a = *(src - d*width_in);
				b = *(src + d*width_in);
				c = *src;
				k = a>b ? (a-c)+(127-((a-b)>>1)) : (c-a)+(127-((b-a)>>1));
				k = k<0 ? 0 : k;
				k = k>255 ? 255 : k;
				//U0
				tmp = *(src_vtmp0 + offsV) * coeff_i2[k] + *(src_vtmp1 + offsV) * ((1<<15) - coeff_i2[k]);
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 1) = tmp;
				//Y1
				*(dst_tmp + 2) = *(src + 1);
				//V0
				tmp = *src_vtmp0 * coeff_i2[k] + *src_vtmp1 * ((1<<15) - coeff_i2[k]);
				tmp = (tmp + 16383) >> 15;
				*(dst_tmp + 3) = tmp;

				src += 2;
				src_vtmp0++;
				src_vtmp1++;
				dst_tmp += 4;
			}
		}
	}
}

/*
 * Pxp interlaced YV12 -> YUY2
 * 2Tv(Tv_^񒆂ɂꍇ)
 * 
 */
static void iyv12_2_yuy2_2xy(unsigned char *dst, unsigned char *src, unsigned char *temp, 
			long width_in, long width_out, long height)
{
	int i,j,k;
	int a,b,c,d;
	int l0, l1;
	int tmp;
	int h_width = width_in >> 1;
	int h_height = height >> 1;
	int offsY = width_in * height;
	int offsV = offsY >> 2;
	unsigned char *dst_tmp = dst;
	unsigned char *src_v = src + offsY;
	unsigned char *src_vtmp0, *src_vtmp1;

	for(i=0; i<height; ++i) {
		dst_tmp = dst + (i+i) * width_out;
		l0 = 2*(i>>2) + (i&1);
		l1 = l0 + ((i>>1)&1) * 4 - 2;
		if(l1<0 || l1>=h_height) {
			l1 = l0;
		}
		src_vtmp0 = src_v + l0 * h_width;
		src_vtmp1 = src_v + l1 * h_width;
		d = ((i&2) - 1)*2;
		if(i<2|| i>=height-2) {
			d = 0;
		}


		for(j=0; j<h_width; ++j) {
			//Y0
			*dst_tmp       = *src;
			//Px̌Xŏd݂ύX
			a = *(src - d*width_in);
			b = *(src + d*width_in);
			c = *src;
			k = a>b ? (a-c)+(127-((a-b)>>1)) : (c-a)+(127-((b-a)>>1));
			k = k<0 ? 0 : k;
			k = k>255 ? 255 : k;
			//U0
			tmp = *(src_vtmp0 + offsV) * coeff[k] + *(src_vtmp1 + offsV) * ((1<<15) - coeff[k]);
			tmp = (tmp + 16383) >> 15;
			*(dst_tmp + 1) = tmp;
			//Y1
			*(dst_tmp + 2) = *(src + 1);
			//V0
			tmp = *src_vtmp0 * coeff[k] + *src_vtmp1 * ((1<<15) - coeff[k]);
			tmp = (tmp + 16383) >> 15;
			*(dst_tmp + 3) = tmp;

			src += 2;
			src_vtmp0++;
			src_vtmp1++;
			dst_tmp += 4;
		}
	}
}

// [eBeB[֐
/*
 *  ]uRs[
 *  unsigned char *dst 
 *  unsigned char *src idst != src łȂƂ߁j
 *  long w      ͉摜̂͂
 *  long h      ͉摜̍
 *  long guard  ݍ݂̂߂̃J[hoĥ͂΁ij
 */
static void transpose(unsigned char *dst, unsigned char *src, long w, long h, long guard)
{
	int i,j,k;
	int hg = h + guard * 2;

	for(i=0; i<hg; ++i) {
		if(i<guard){
			k = 0;
		}else if(i<hg-guard){
			k = i - guard;
		}else{
			k = h - 1;
		}
		for(j=0; j<w; ++j) {
			dst[j*hg + i] = src[k*w + j];
		}
	}
}

