//  iyv12.cpp
//
//	YV12 to YUY2 converter
//
//	Copyright (c)
//

#define WIN32_LEAN_AND_MEAN		// Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>

#include <streams.h>
#include <dvdmedia.h>
#include <aviriff.h> 
#include <initguid.h>
#include "iyv12.h"
#include "convf.h"


extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}

/* consructor */
Ciyv12::Ciyv12(TCHAR *tszName, LPUNKNOWN punk)
	: CTransformFilter (tszName, punk, CLSID_IYV12)
{ 
	hIn = wIn = swIn = swOut = wOut = hOut = 0;

	m_nFunc = 	LoadRegistryInfo();
	if (m_nFunc < 0|| m_nFunc > FUNC_N) {
		m_nFunc = 0;
	}

	pTemp = NULL;
}

/* destructor */
Ciyv12::~Ciyv12()
{ 
	/*
	if(pTemp) {
		VirtualFree(pTemp, 0, MEM_RELEASE);
	}
	*/

	SaveRegistryInfo(m_nFunc);
}

/* create instance */
CUnknown *Ciyv12::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
    Ciyv12 *pFilter = new Ciyv12(NAME("interlaced YV12 to YUY2 converter"), pUnk);
    if (pFilter== NULL) 
    {
        *pHr = E_OUTOFMEMORY;
    }
    return pFilter;
}

//͂̃`FbN
HRESULT Ciyv12::CheckInputType(const CMediaType *mtIn)
{
    if (mtIn->majortype != MEDIATYPE_Video)
	{
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

    if (mtIn->subtype != MEDIASUBTYPE_YV12)
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	BITMAPINFOHEADER *pbmi;
	if (mtIn->formattype == FORMAT_VideoInfo 
		&& mtIn->cbFormat >= sizeof(VIDEOINFOHEADER)){
			pbmi = &(((VIDEOINFOHEADER *)(mtIn->Format()))->bmiHeader);
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 
		&& mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2)){
			pbmi = &(((VIDEOINFOHEADER2 *)(mtIn->Format()))->bmiHeader);
	}
	else{
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	if (pbmi->biCompression != FCC('YV12')){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}


    // ׂĖȂB
    return S_OK;
}

//o͌`̒
HRESULT Ciyv12::GetMediaType(int iPosition, CMediaType *pMediaType)
{
     ASSERT(m_pInput->IsConnected());
    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }
    if (iPosition == 0)
    {
        HRESULT hr = m_pInput->ConnectionMediaType(pMediaType);
        if (FAILED(hr))
        {
            return hr;
        }
        pMediaType->subtype = MEDIASUBTYPE_YUY2;

		//BITMAPINFOHEADERł̃^Cvw
        BITMAPINFOHEADER *pbmi;
		if (pMediaType->formattype == FORMAT_VideoInfo 
			&& pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER))
		{
			pbmi = &((VIDEOINFOHEADER *)(pMediaType->Format()))->bmiHeader;
		}
		else if (pMediaType->formattype == FORMAT_VideoInfo2 
			&& pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER2))
		{
			pbmi = &((VIDEOINFOHEADER2 *)(pMediaType->Format()))->bmiHeader;
		}
		else
		{
			return E_UNEXPECTED;
		}

		pbmi->biCompression = FCC('YUY2');
		pbmi->biBitCount = 16;
		pbmi->biWidth = pbmi->biWidth + pbmi->biWidth % sizeof(DWORD);
		pbmi->biSizeImage = pbmi->biWidth * abs(pbmi->biHeight) * 2;

        return S_OK;
    }
    // else
    return VFW_S_NO_MORE_ITEMS;
}

//`FbN
HRESULT Ciyv12::CheckTransform(
    const CMediaType *mtIn, const CMediaType *mtOut)
{
	BITMAPINFOHEADER *pbmiIn, *pbmiOut;
	RECT *prcSrc, *prcTarget;

	if (mtIn->formattype == FORMAT_VideoInfo 
		&& mtIn->cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pbmiIn = &((VIDEOINFOHEADER *)(mtIn->pbFormat))->bmiHeader;
		prcSrc = &((VIDEOINFOHEADER *)(mtIn->pbFormat))->rcSource;
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 
		&& mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		pbmiIn = &((VIDEOINFOHEADER2 *)(mtIn->pbFormat))->bmiHeader;
		prcSrc = &((VIDEOINFOHEADER2 *)(mtIn->pbFormat))->rcSource;
	}else{
		return E_UNEXPECTED;
	}

	if (mtOut->formattype == FORMAT_VideoInfo 
		&& mtOut->cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pbmiOut   = &((VIDEOINFOHEADER *)(mtOut->Format()))->bmiHeader;
		prcTarget = &((VIDEOINFOHEADER *)(mtOut->Format()))->rcTarget;
	}
	else if (mtOut->formattype == FORMAT_VideoInfo2 
		&& mtOut->cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		pbmiOut   = &((VIDEOINFOHEADER2 *)(mtOut->Format()))->bmiHeader;
		prcTarget = &((VIDEOINFOHEADER2 *)(mtOut->Format()))->rcTarget;
	}else{
		return E_UNEXPECTED;
	}

	//biWidth̓XgCh̒l
	swOut = pbmiOut->biWidth;
	hOut = abs(pbmiOut->biHeight);
	swIn = pbmiIn->biWidth;
	hIn = abs(pbmiIn->biHeight);

	//قȂ邱Ƃ͂肦ȂEE
	if (hOut != hIn) {
		return VFW_E_INVALIDMEDIATYPE;
	}

	// ]`Ɠ]`rB
	// ܂Ӗ킩ĂȂB
    RECT rcImg;
	SetRect(&rcImg, 0, 0, swIn, hIn);
	if (IsRectEmpty(prcSrc) || EqualRect(prcSrc, &rcImg)) {
		// XgChlȂĂ悢ꍇ
		wIn = swIn;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcSrc->right;
		// ̓f[^̃XgChl
		if(!EqualRect(prcSrc, &rcImg2) || rcImg2.right>swIn) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		wIn = rcImg2.right;
	}
	SetRect(&rcImg, 0, 0, swOut, hOut);
	if (IsRectEmpty(prcTarget) || EqualRect(prcTarget, &rcImg)) {
		wOut = swOut;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcTarget->right;
		// o̓f[^̃XgChl
		if(!EqualRect(prcTarget, &rcImg2) || rcImg2.right>swOut) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		wOut = rcImg2.right;
	}

	// wOut,wIn͌󗘗pĂȂǁAꉞ`FbN
	if (wOut != wIn) {
		return VFW_E_INVALIDMEDIATYPE;
	}
	
    // ׂĖȂB
    return S_OK;
	
}

HRESULT Ciyv12::DecideBufferSize(
    IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp)
{
    AM_MEDIA_TYPE mt;
    HRESULT hr = m_pOutput->ConnectionMediaType(&mt);
    if (FAILED(hr))
    {
        return hr;
    }

    //BITMAPINFOHEADERTCY𓾂
    BITMAPINFOHEADER *pbmi;
	if (mt.formattype == FORMAT_VideoInfo 
		&& mt.cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pbmi = &((VIDEOINFOHEADER *)(mt.pbFormat))->bmiHeader;
	} else if (mt.formattype == FORMAT_VideoInfo2 &&
		mt.cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		pbmi = &((VIDEOINFOHEADER2 *)(mt.pbFormat))->bmiHeader;
	} else {
		//ɂ͗Ȃ
		return E_UNEXPECTED;
	}

	//obt@TCY
	pProp->cbBuffer = DIBSIZE(*pbmi);

	/*
	//ϊpe|̈ŊmۂĂ݂iK؂ȏꏊHj
	if(pTemp) {
		VirtualFree(pTemp, 0, MEM_RELEASE);
	}
	SIZE_T size = pbmi->biWidth * abs(pbmi->biHeight) * 2; // Ƃ肠HxWx2
	pTemp = (BYTE *)VirtualAlloc(NULL, size, MEM_COMMIT, PAGE_READWRITE);
	if(pTemp == NULL) {
		return E_OUTOFMEMORY;
	}
	*/
	

    if (pProp->cbAlign == 0)
    {
        pProp->cbAlign = 1;
    }
    if (pProp->cBuffers == 0)
    {
        pProp->cBuffers = 1;
    }
    // tH[}bg ubNB
    FreeMediaType(mt);

    // AP[^ vpeBݒ肷B
    ALLOCATOR_PROPERTIES Actual;
    hr = pAlloc->SetProperties(pProp, &Actual);
    if (FAILED(hr)) 
    {
        return hr;
    }
    // ꍇAۂ̌ʂmFB
    if (pProp->cbBuffer > Actual.cbBuffer) 
    {
        return E_FAIL;
    }
    return S_OK;
}

//ۂ̕ϊ
HRESULT Ciyv12::Transform(IMediaSample *pSource, IMediaSample *pDest)
{
	// _EXg[̃tH[}bgύXB
    CMediaType *pMT = NULL;
    HRESULT hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
    if (hr == S_OK)
    {
        hr = m_pOutput->CheckMediaType(pMT);
        if(FAILED(hr))
        {
            DeleteMediaType(pMT);
            return E_FAIL;
        }
        // V^CvɂĎg̏o̓sɒʒmB
        m_pOutput->SetMediaType(pMT);
        DeleteMediaType(pMT);
    }

    // ɂȂobt@ւ̃|C^擾B
    BYTE *pBufferIn, *pBufferOut;
    hr = pSource->GetPointer(&pBufferIn);
    if (FAILED(hr))
    {
        return hr;
    }
    hr = pDest->GetPointer(&pBufferOut);
    if (FAILED(hr))
    {
        return hr;
    }
    // f[^B
	//CopyMemory(pBufferOut, pBufferIn, pSource->GetSize());
	//iyv12_2_yuy2(pBufferOut, pBufferIn, pTemp, swIn, swOut, hIn);
	func_tbl[m_nFunc](pBufferOut, pBufferIn, pTemp, swIn, swOut, hIn);

	//ۂ̃f[^ʒm
	pDest->SetActualDataLength(2 * swOut * hOut);
	//L[t[łB
    pDest->SetSyncPoint(TRUE);
    
    return S_OK;
}

//tB^̓o^
STDAPI DllRegisterServer(void)
{
    HRESULT hr = AMovieDllRegisterServer2(TRUE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->RegisterFilter(
            CLSID_IYV12,           // tB^ CLSIDB
            g_wszName,                       // tB^B
            NULL,                            // foCX jJB
            &CLSID_LegacyAmFilterCategory,   // Dsf
            NULL,                       // CX^X f[^B
            &rf2FilterReg                    // tB^B
            );
        pFM2->Release();
    }
    return hr;
}

//tB^̓o^
STDAPI DllUnregisterServer()
{
    HRESULT hr = AMovieDllRegisterServer2(FALSE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
            NULL, CLSID_IYV12);
        pFM2->Release();
    }
    return hr;
}

/* get property page list */
STDMETHODIMP Ciyv12::GetPages(CAUUID *pPages)
    {
        if (pPages == NULL) return E_POINTER;
        pPages->cElems = 1;
        pPages->pElems = (GUID*)CoTaskMemAlloc(sizeof(GUID));
        if (pPages->pElems == NULL) 
        {
            return E_OUTOFMEMORY;
        }
        pPages->pElems[0] = CLSID_IYV12Prop;
        return S_OK;
    }

/* query interfaces */
STDMETHODIMP Ciyv12::NonDelegatingQueryInterface(REFIID riid, void **ppv)
{
    if (riid == IID_ISpecifyPropertyPages)
    {
        return GetInterface(static_cast<ISpecifyPropertyPages*>(this),
           ppv);
    }
    if (riid == IID_IIYV12)
    {
        return GetInterface(static_cast<IIYV12*>(this), ppv);
    }
    return CBaseFilter::NonDelegatingQueryInterface(riid, ppv);
}

// IIYV12 vpeB[̓ǂݍ
STDMETHODIMP Ciyv12::GetN(DWORD *pnFunc)
{
	if (!pnFunc) return E_POINTER;
	CAutoLock lock(&m_csShared);
	*pnFunc = m_nFunc;
	return S_OK;
}

// IIYV12 vpeB[y[W֒ʒm
STDMETHODIMP Ciyv12::SetN(DWORD nFunc)
{
	if (nFunc < 0|| nFunc > FUNC_N)
	{
	return E_INVALIDARG;
	}
	CAutoLock lock(&m_csShared);
	m_nFunc = nFunc;
	return S_OK;
}


